<script lang="ts">
    import { handleConsole, handleGlobalErrors } from './utils';
    import { onMount } from 'svelte';

    let consoleList: {type: string; message: string}[] = [];

    handleConsole({
        error: function () {
            const args: string[] = Array.prototype.slice.call(arguments).map(argument => {
                return argument instanceof Object ? JSON.stringify(argument) : argument;
            })
            consoleList = consoleList.concat({type: 'error', message: args.join('\t')});
        },
        warn: function () {
            const args: string[] = Array.prototype.slice.call(arguments).map(argument => {
                return argument instanceof Object ? JSON.stringify(argument) : argument;
            })
            consoleList = consoleList.concat({type: 'warn', message: args.join('\t')});
        },
        log: function () {
            const args: string[] = Array.prototype.slice.call(arguments).map(argument => {
                return argument instanceof Object ? JSON.stringify(argument) : argument;
            })
            consoleList = consoleList.concat({type: 'log', message: args.join('\t')});
        }
    });

    handleGlobalErrors(function () {
        console.log('erreur attrapée : ', arguments);
    });

    onMount(() => {
    });
</script>

<div class="ks-logs">
    <ul>
        {#each consoleList as consoleEntry}
            <li class="{consoleEntry.type}">{consoleEntry.message || ' '}</li>
        {/each}
    </ul>
    <br><br><br><br>
</div>

<style lang="scss">
    .ks-logs {
        background-color: white;
        height: 100%;

        ul {
            margin: 0;
            padding: 0;
            list-style: none;
        }

        li {
            tab-size: 4;
            padding-left: 16px;
            white-space: pre-wrap;

            &.log {
                background-color: white;
                border-bottom: 1px solid #ddd;
            }
            &.warn {
                background-color: #fff085;
                border-bottom: 1px solid #f8e810;
            }
            &.error {
                background-color: #ffe7e7;
                color: red;
                border-bottom: 1px solid #fcdada;
            }
        }
    }
</style>
